import java.awt.*;
import java.applet.*;

public class collisionTest
{
    /*________________________________
    ___________Variable_____________*/
    pigFunc pig;
    vectorFunc v;
    collisionFunc coll;

    vector boxPos,
           boxSize,
           circleCenter;
    float circleRadius;
    
    vector a,
           b,
           c,
           d,
           center,
           rotate;

    vector t1,
           t2,
           t3;

    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        pig = new pigFunc();
        v = new vectorFunc();
        coll = new collisionFunc();
        
        boxPos = new vector(50,350);
        boxSize = new vector(100,100);
        
        circleCenter = new vector(300,400);
        circleRadius = 50;
        
        a = new vector(120,420);
        b = new vector(270,420);
        c = new vector(270,570);
        d = new vector(120,570);
        center = new vector(195,495);
        rotate = v.fromRadian(0.01);
        
        t1 = new vector(350,495);
        t2 = new vector(280,495);
        t3 = new vector(350,550);
        
    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {
        a = v.add(center,v.rotate(v.sub(a,center),rotate));
        b = v.add(center,v.rotate(v.sub(b,center),rotate));
        c = v.add(center,v.rotate(v.sub(c,center),rotate));
        d = v.add(center,v.rotate(v.sub(d,center),rotate));
    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(0,320,100,320);
        g.drawString("collision Test",102,324);
        
        //draw square
        g.setColor(Color.blue);
        g.drawRect(50,350,100,100);
        
        //draw circle
        pig.circle(g, circleCenter, circleRadius);
        
        //draw polygone
        g.setColor(Color.green);
        pig.line(g,a,b);
        pig.line(g,b,c);
        pig.line(g,c,d);
        pig.line(g,d,a);
        pig.point(g,center);
        
        //test circle circle collision
        if (coll.circleCircle(d,30,circleCenter, circleRadius))
            g.setColor(Color.black);
        else
            g.setColor(Color.blue);
        pig.circle(g,d,30);
        
        
        //test box collision
        g.setColor(Color.black);
        if (coll.pointBox(a,boxPos,boxSize))
            pig.text(g,"true",a);
        if (coll.pointBox(b,boxPos,boxSize))
            pig.text(g,"true",b);
        if (coll.pointBox(c,boxPos,boxSize))
            pig.text(g,"true",c);
//        if (coll.pointBox(d,boxPos,boxSize))
//            pig.text(g,"true",d);
        
        //test circle collision
        if (coll.pointCircle(a,circleCenter, circleRadius))
            pig.text(g,"true",a);
        if (coll.pointCircle(b,circleCenter, circleRadius))
            pig.text(g,"true",b);
        if (coll.pointCircle(c,circleCenter, circleRadius))
            pig.text(g,"true",c);
//        if (coll.pointCircle(d,circleCenter, circleRadius))
//            pig.text(g,"true",d);
            
        //draw triangle
        g.setColor(Color.red);
        pig.line(g,t1,t2);
        pig.line(g,t2,t3);
        pig.line(g,t3,t1);
        
        //test lineline collision
        g.setColor(Color.black);
        if (coll.lineLine(a,b,t1,t2))
        {
            pig.line(g,t1,t2);
            pig.line(g,a,b);
            }
        if (coll.lineLine(b,c,t1,t2))
        {
            pig.line(g,t1,t2);
            pig.line(g,b,c);
            }
        if (coll.lineLine(c,d,t1,t2))
        {
            pig.line(g,t1,t2);
            pig.line(g,c,d);
            }
        if (coll.lineLine(d,a,t1,t2))
        {
            pig.line(g,t1,t2);
            pig.line(g,d,a);
            }
        if (coll.lineLine(a,b,t2,t3))
        {
            pig.line(g,t2,t3);
            pig.line(g,a,b);
            }
        if (coll.lineLine(b,c,t2,t3))
        {
            pig.line(g,t2,t3);
            pig.line(g,b,c);
            }
        if (coll.lineLine(c,d,t2,t3))
        {
            pig.line(g,t2,t3);
            pig.line(g,c,d);
            }
        if (coll.lineLine(d,a,t2,t3))
        {
            pig.line(g,t2,t3);
            pig.line(g,d,a);
            }
    }
}
